## ros-foxy-naoqi-driver 2.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(naoqi_driver)

find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(cv_bridge REQUIRED)
find_package(diagnostic_msgs REQUIRED)
find_package(diagnostic_updater REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(image_transport REQUIRED)
find_package(kdl_parser REQUIRED)
find_package(naoqi_bridge_msgs REQUIRED)
find_package(naoqi_libqi REQUIRED)
find_package(naoqi_libqicore REQUIRED)
find_package(robot_state_publisher REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(tf2_geometry_msgs REQUIRED)
find_package(tf2_msgs REQUIRED)
find_package(tf2_ros REQUIRED)
find_package(OpenCV REQUIRED)
find_package(orocos_kdl REQUIRED)
find_package(Boost QUIET COMPONENTS chrono filesystem program_options regex system thread random)

# define source files that can be used by qibuild or catkin
set(
  CONVERTERS_SRC
  src/converters/audio.cpp
  src/converters/touch.cpp
  src/converters/camera.cpp
  src/converters/diagnostics.cpp
  src/converters/imu.cpp
  src/converters/info.cpp
  src/converters/joint_state.cpp
  src/converters/laser.cpp
  src/converters/memory_list.cpp
  src/converters/memory/bool.cpp
  src/converters/memory/int.cpp
  src/converters/memory/float.cpp
  src/converters/memory/string.cpp
  src/converters/sonar.cpp
  src/converters/log.cpp
  src/converters/odom.cpp
  )
set(
  TOOLS_SRC
  src/tools/robot_description.cpp
  src/tools/from_any_value.cpp
  )

set(
  PUBLISHER_SRC
  src/publishers/camera.cpp
  src/publishers/info.cpp
  src/publishers/joint_state.cpp
  src/publishers/log.cpp
  src/publishers/sonar.cpp
  )

set(
  SUBSCRIBER_SRC
  src/subscribers/teleop.cpp
  src/subscribers/moveto.cpp
  src/subscribers/speech.cpp
  )

set(
  SERVICES_SRC
  src/services/robot_config.cpp
  src/services/set_language.cpp
  src/services/get_language.cpp
  )

set(
  RECORDER_SRC
  src/recorder/camera.cpp
  src/recorder/diagnostics.cpp
  src/recorder/joint_state.cpp
  src/recorder/log.cpp
  src/recorder/sonar.cpp
  )

set(
  DRIVER_SRC
  src/naoqi_driver.cpp
  src/helpers/driver_helpers.cpp
  src/helpers/ros_helpers.cpp
  src/recorder/globalrecorder.cpp
  src/event/basic.hxx
  src/event/basic.hpp
  src/event/audio.cpp
  src/event/touch.cpp
)

add_definitions(-DLIBQI_VERSION=${naoqi_libqi_VERSION_MAJOR}${naoqi_libqi_VERSION_MINOR})

# Add pre-processor compile flag indicating ament
add_definitions( -DAMENT_BUILD )

include_directories(include 
  ${naoqi_libqi_INCLUDE_DIRS}
  ${OpenCV_INCLUDE_DIRS}
  ${orocos_kdl_INCLUDE_DIRS})

# create the different libraries
# add_library(
#   naoqi_driver_module
#   SHARED
#   src/autoload_registration.cpp
# )

# target_link_libraries(naoqi_driver_module ${naoqi_libqi_LIBRARIES})
# ament_target_dependencies(naoqi_driver_module
#     naoqi_libqi)

# install(TARGETS naoqi_driver_module DESTINATION lib/${PROJECT_NAME})

add_library(
  naoqi_driver
  SHARED
  ${DRIVER_SRC}
  ${CONVERTERS_SRC}
  ${PUBLISHER_SRC}
  ${SUBSCRIBER_SRC}
  ${SERVICES_SRC}
  ${RECORDER_SRC}
  ${TOOLS_SRC}
)

ament_target_dependencies(naoqi_driver
  rclcpp
  cv_bridge
  diagnostic_msgs
  diagnostic_updater
  geometry_msgs
  image_transport
  kdl_parser
  naoqi_bridge_msgs
  naoqi_libqi
  naoqi_libqicore
  robot_state_publisher
  sensor_msgs
  tf2_geometry_msgs
  tf2_msgs
  tf2_ros
  OpenCV
  orocos_kdl
  Boost)

install(TARGETS naoqi_driver DESTINATION lib/)

# target_link_libraries(naoqi_driver_module
#   naoqi_driver
# )

# create the binary of the bridge
add_executable(naoqi_driver_node src/external_registration.cpp)
target_link_libraries(naoqi_driver_node
    naoqi_driver
    ${rclcpp_LIBRARIES}
    ${naoqi_libqi_LIBRARIES}
    ${Boost_LIBRARIES}
)

install(TARGETS naoqi_driver_node DESTINATION lib/${PROJECT_NAME})

# install the urdf for runtime loading
# file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/share DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/)
# install(DIRECTORY share DESTINATION "${CATKIN_PACKAGE_SHARE_DESTINATION}")
install(DIRECTORY share DESTINATION share/${PROJECT_NAME})

# install the launch files
# install(DIRECTORY launch DESTINATION "${CATKIN_PACKAGE_SHARE_DESTINATION}")
install(DIRECTORY launch DESTINATION share/${PROJECT_NAME})

# make sure there is a file describing a naoqi module
# file(WRITE ${CATKIN_DEVEL_PREFIX}/${CATKIN_GLOBAL_SHARE_DESTINATION}/qi/module/naoqi_driver_module.mod "cpp")
# install(FILES ${CATKIN_DEVEL_PREFIX}/${CATKIN_GLOBAL_SHARE_DESTINATION}/qi/module/naoqi_driver_module.mod DESTINATION ${CATKIN_GLOBAL_SHARE_DESTINATION}/qi/module/)
# file(WRITE share/${PROJECT_NAME}/qi/module/naoqi_driver_module.mod "cpp")

# ament_export_libraries(naoqi_driver_module naoqi_driver)
ament_export_libraries(naoqi_driver)
ament_package()

=== debian/changelog ===
ros-foxy-naoqi-driver (2.0.0-0focal) focal; urgency=high

  * Update README, add buildfarm status badges
  * Fix typos in README, update username arg in launchfile
  * Merge branch 'ros2_integration' into main
  * Remove old README
  * Migrate Travis CI to github actions, remove spurious README
  * Update the package version, add a README.md
  * Initial commit
  * Fix robot_state_publisher header import
  * Merge branch 'naoqi-2.9' into ros2_integration
  * Merge branch 'temp_tests' into naoqi-2.9
  * Correct include towards ros_helper, and small functional updates
  * Refactor the converters for NAOqi 2.9 compatibility
  * Refactor the audio event for NAOqi 2.9 compatibility
  * Add the NaoqiVersion struct
  * Add the getNaoqiVersion and isNaoqiVersionLesser methods, refactor the getInfoRobotLocal method
  * Update the package definition and its CMakeLists
  * Fix the Driver class
  * Fix the subscribers
  * Fix the services
  * Fix the recorders
  * Fix the publishers
  * Fix the helpers
  * Fix the events
  * Fix the converters
  * Fix project headers
  * Merge pull request #10 <https://github.com/ros-naoqi/naoqi_driver2/issues/10> from arturocuma/subscriber_refactoring
    Subscriber refactoring
  * Merge pull request #9 <https://github.com/ros-naoqi/naoqi_driver2/issues/9> from mcaniot/publishers_refactoring
    Publishers refactoring
  * Merge pull request #8 <https://github.com/ros-naoqi/naoqi_driver2/issues/8> from elagrue/event_refactoring
    Event refactoring
  * Merge pull request #7 <https://github.com/ros-naoqi/naoqi_driver2/issues/7> from mbusy/converters_refactoring
    Converters refactoring
  * Merge pull request #6 <https://github.com/ros-naoqi/naoqi_driver2/issues/6> from mbusy/migration_helpers
    Migration helpers
  * Merge pull request #5 <https://github.com/ros-naoqi/naoqi_driver2/issues/5> from mbusy/driver_refactoring
    Driver refactoring
  * Merge pull request #4 <https://github.com/ros-naoqi/naoqi_driver2/issues/4> from mbusy/services_refactoring
    Services refactoring
  * Merge pull request #3 <https://github.com/ros-naoqi/naoqi_driver2/issues/3> from mbusy/helpers_refactoring
    Helpers refactoring
  * Merge pull request #2 <https://github.com/ros-naoqi/naoqi_driver2/issues/2> from mbusy/recorders_refactoring
    Recorders refactoring
  * Merge pull request #1 <https://github.com/ros-naoqi/naoqi_driver2/issues/1> from mbusy/interface_headers
    Interface headers
  * adding const at speech_callback
  * changing ConstSharedPtr to ConstSharedPtr&
  * pull request changes
  * refactor teleop subscriber for geometry_msgs, naoqi_bridge_msgs compliancy
  * refactor speech subscriber for rclcpp, std_msgs compliancy
  * refactor moveto for rclcpp, geometry_msgs compliancy
  * Fix Refactor sonar publisher
    replace it by (*it)
  * Fix Refactor camera publisher
    replace create_publisher by create_camera_publisher
  * Event refactoring minor bugfix
  * Fix Refactor sonar publisher
    replace Publisher with Publisher<sensor_msgs::msg::Range>::SharedPtr
    replace publishers::getNumSubscribers by Node::count_subscribers
    use clear() function to reset vector pubs_
    replace . by ->
  * Fix Refactor log publisher
    remove header serialization.h
    replace Publisher by Publisher<rcl_interfaces::msg::Log>::SharedPtr
  * Fix helpers called function
    replace getNumSubscribers by count_subscribers
  * Fix Refactor joint_state publisher
    replace rclcpp::Publisher by rclcpp::Publisher<sensor_msgs::msg::JointState>::SharedPtr
    replace . by ->
  * Fix Refactor Info
    remove unnecessary parameters
    replace StringStamped by string_stamped
  * Fix Refactor Camera publisher
    Add note above commented code
    remove unused header
    replace helpers::pulishers by helpers::Node
  * Fix Refactor basic publisher
    replace rclcpp::Publisher by rclcpp::Publisher<T>::SharedPtr
  * Fix Refactor basic publisher
    replace helpers::publishers by helper::Node
  * Specify the IP address when calling the stopRecord method in the Driver class
  * Remove the Master URI related methods in ros_env.hpp
  * Fix include names for the driver_helpers header
  * Global fix for the services
  * Fix the converter accoring to the review of PR #7 <https://github.com/ros-naoqi/naoqi_driver2/issues/7>
  * Refactor Camera publisher
    add msg namespace
    replace ros::NodeHandle by rclcpp::Node
    replace . by pointer ->
    replace ros by rclcpp
    add helpers to replace deprecaded getNumSubscribers
    comment if that remove compressedDepth topics check if still poping in ros2
  * Refactor the touch event
  * Refactor the basic event
  * Refactor the audio event
  * Refactor the touch converter
  * Refactor the sonar converter
  * Refactor the odom converter
  * Refactor the nao footprint header
  * Refactor info publisher
    add msg namespace
    replace ros::NodeHandle by rclcpp::Node
    replace . by pointer ->
    replace ros by rclcpp
    replace setParam by set_parameters
  * Refactor the memory list converter
  * Refactor sonar publisher
    add msg namespace
    replace ros::NodeHandle by rclcpp::Node
    replace . by pointer ->
    replace advertise by create_publisher
    replace ros by rclcpp
    add helpers to replace getNumSubscribers
  * Refactor log publisher
    replace ros bu rclcpp
    replace rosgraph_msgs by rcl_interfaces/msg
  * Refactor the joint_state publisher
    add msg namespace
    replace ros::NodeHandle by rclcpp::Node
    replace . by pointer ->
    replace advertise by create_publisher
    replace ros by rclcpp
  * Refactor the basic publisher
    add msg namespace
    replace ros::NodeHandle by rclcpp::Node
    replace . by pointer ->
    replace advertise by create_publisher
    replace ros by rclcpp
    add helpers function to replace getNumSubscribers
  * Refactor the log converter. Use rcl_interfaces::msg::Log and the RCUTILS_LOG_SEVERITY enum


=== debian/control ===
Source: ros-foxy-naoqi-driver
Section: misc
Priority: optional
Maintainer: Marine Chamoux <mchamoux@softbankrobotics.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, ros-foxy-ament-cmake, ros-foxy-ament-lint-auto <!nocheck>, ros-foxy-ament-lint-common <!nocheck>, ros-foxy-cv-bridge, ros-foxy-diagnostic-msgs, ros-foxy-diagnostic-updater, ros-foxy-geometry-msgs, ros-foxy-image-transport, ros-foxy-kdl-parser, ros-foxy-naoqi-bridge-msgs (>= 2.0.0), ros-foxy-naoqi-libqi, ros-foxy-naoqi-libqicore, ros-foxy-orocos-kdl, ros-foxy-rclcpp, ros-foxy-robot-state-publisher, ros-foxy-sensor-msgs, ros-foxy-tf2-geometry-msgs, ros-foxy-tf2-msgs, ros-foxy-tf2-ros, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-naoqi-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-foxy-cv-bridge, ros-foxy-image-transport, ros-foxy-kdl-parser, ros-foxy-naoqi-bridge-msgs (>= 2.0.0), ros-foxy-naoqi-libqi, ros-foxy-naoqi-libqicore, ros-foxy-orocos-kdl, ros-foxy-rclcpp, ros-foxy-robot-state-publisher, ros-foxy-tf2-ros, ros-foxy-ros-workspace
Conflicts: ros-foxy-nao-driver, ros-foxy-naoqi-rosbridge
Description: Driver module between Aldebaran's NAOqiOS and ROS2.
 It publishes all sensor and actuator data as well as basic diagnostic for battery, temperature. It subscribes also to RVIZ simple goal and cmd_vel for teleop.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-naoqi-driver//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
